<template>
  <div>
    <div class="row q-col-gutter-xs">
      <div class="col-12" v-if="combos.lugar.length === 0 && !loading">
        <q-banner class="text-white bg-red">
          Debe tener cargado "Un lugar" para crear un nuevo evento
          <br />
          El mismo se crea en Eventos => Lugares => Nuevo
        </q-banner>
      </div>

      <div class="col-12">
        <q-card>
          <q-card-section class="row q-col-gutter-xs q-pa-md">
            <div class="col-md-3 col-xs-12">
              <div class="q-gutter-md">
                <q-select
                  v-model="form.eventos_tipo_id"
                  style="min-width: 150px"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  option-value="id"
                  option-label="nombre"
                  :options="combos.area.eventos_tipo"
                  label="Tipo de Evento"
                  hide-bottom-space
                  :error="validacion.has('eventos_tipo_id')"
                  :error-message="validacion.first('eventos_tipo_id')"
                >
                  <template v-slot:prepend>
                    <q-icon name="foundation" />
                  </template>
                </q-select>

                <q-select
                  v-if="form.eventos_tipo_id === 9"
                  v-model="form.ams_experiencias_id"
                  style="min-width: 150px"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  option-value="id"
                  option-label="nombre"
                  :options="combos.experiencias"
                  label="Experiencia de formacion"
                  hide-bottom-space
                  :error="validacion.has('ams_experiencias_id')"
                  :error-message="validacion.first('ams_experiencias_id')"
                >
                  <template v-slot:prepend>
                    <q-icon name="fas os-area-ams" />
                  </template>

                  <template v-slot:option="scope">
                    <q-item v-bind="scope.itemProps">
                      <q-item-section> {{ scope.opt.nombre }}</q-item-section>
                      <q-item-section side>
                        <q-chip
                          dense
                          square
                          :color="scope.opt.instancias.color"
                          text-color="white"
                        >
                          {{ scope.opt.instancias.nombre }}
                        </q-chip>
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>
                <q-input
                  v-if="
                    (form.ams_experiencias_id === 2 &&
                      form.eventos_tipo_id === 9) ||
                    (form.eventos_tipo_id !== 9 &&
                      form.eventos_tipo_id !== null &&
                      form.eventos_tipo_id !== 12)
                  "
                  v-model="form.nombre"
                  filled
                  dense
                  label="Nombre del evento:"
                  hide-bottom-space
                  :error="validacion.has('nombre')"
                  :error-message="validacion.first('nombre')"
                >
                  <template v-slot:prepend>
                    <q-icon name="notifications" />
                  </template>
                </q-input>

                <q-input
                  v-if="form.crea_ams === 'S'"
                  v-model="form.carga_horaria"
                  filled
                  dense
                  label="Carga Horaria:"
                  hide-bottom-space
                  :error="validacion.has('carga_horaria')"
                  :error-message="validacion.first('carga_horaria')"
                >
                  <template v-slot:prepend>
                    <q-icon name="alarm" />
                  </template>
                </q-input>

                <q-select
                  v-model="form.participa"
                  style="min-width: 150px"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  option-disable="disable"
                  :options="[
                    {
                      label: 'Solo a mi zona',
                      value: 'Z',
                      disable: user.is.grupo,
                    },
                    {
                      label: 'Solo a mi distrito',
                      value: 'D',
                      disable: user.is.zona,
                    },
                    {
                      label: 'Solo mi Organismo (Privado)',
                      value: 'P',
                      disable: !user.is.grupo,
                    },
                    {
                      label: 'A todo el pais',
                      value: 'N',
                      disable: !user.is.zona,
                    },
                  ]"
                  label="Disponible para: "
                  hide-bottom-space
                  :error="validacion.has('participa')"
                  :error-message="validacion.first('participa')"
                >
                  <template v-slot:prepend>
                    <q-icon name="sensor_occupied" />
                  </template>
                </q-select>
              </div>
            </div>
            <!-----------------------------------------------------------------------------------------------------
                  COLUMNA 2
        ----------------------------------------------------------------------------------------------------->
            <div class="col-md-3 col-xs-12">
              <div class="q-gutter-md">
                <q-select
                  v-model="form.modalidad"
                  style="min-width: 150px"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  @update:model-value="cambiarModalidad"
                  :options="[
                    {
                      label: 'Presencial',
                      value: 'P',
                    },
                    {
                      label: 'Virtual',
                      value: 'V',
                    },
                    {
                      label: 'Mixto',
                      value: 'M',
                    },
                  ]"
                  label="Modalidad: "
                  hide-bottom-space
                  :error="validacion.has('modalidad')"
                  :error-message="validacion.first('modalidad')"
                >
                  <template v-slot:prepend>
                    <q-icon name="apartment" />
                  </template>
                </q-select>

                <q-select
                  v-if="form.modalidad != 'V'"
                  v-model="form.eventos_lugar_id"
                  style="min-width: 150px"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  option-value="id"
                  option-label="nombre"
                  :options="combos.lugar"
                  label="Lugar:"
                  hide-bottom-space
                  :error="validacion.has('eventos_lugar_id')"
                  :error-message="validacion.first('eventos_lugar_id')"
                >
                  <template v-slot:prepend>
                    <q-icon name="place" />
                  </template>
                  <template v-slot:option="scope">
                    <q-item v-bind="scope.itemProps">
                      <q-item-section>
                        <q-item-label>
                          {{ scope.opt.nombre }}
                        </q-item-label>
                        <q-item-label caption>
                          Direccion: {{ scope.opt.direccion }}
                          <span v-if="scope.opt.localidad">
                            / {{ scope.opt.localidad }}
                          </span>
                        </q-item-label>
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>

                <q-input
                  v-model="form.costo"
                  filled
                  dense
                  label="Costo del evento"
                  hide-bottom-space
                  :error="validacion.has('costo')"
                  :error-message="validacion.first('costo')"
                >
                  <template v-slot:prepend>
                    <q-icon name="attach_money" />
                  </template>
                </q-input>

                <InputBuscar
                  v-model="form.responsable_uuid"
                  dense
                  filled
                  label="Responsable del evento:"
                  hide-bottom-space
                  :error="validacion.has('responsable_uuid')"
                  :error-message="validacion.first('responsable_uuid')"
                />
              </div>
            </div>
            <!-----------------------------------------------------------------------------------------------------
                  COLUMNA 3
        ----------------------------------------------------------------------------------------------------->
            <div class="col-md-3 col-xs-12">
              <div class="q-gutter-md">
                <q-input
                  filled
                  dense
                  label="Cierre Inscripciones"
                  v-model="form.f_cierre_inscripcion"
                  mask="date"
                  hide-bottom-space
                  :error="validacion.has('f_cierre_inscripcion')"
                  :error-message="validacion.first('f_cierre_inscripcion')"
                >
                  <template v-slot:prepend>
                    <q-icon name="event" class="cursor-pointer">
                      <q-popup-proxy
                        cover
                        transition-show="scale"
                        transition-hide="scale"
                      >
                        <q-date v-model="form.f_cierre_inscripcion">
                          <div class="row items-center justify-end">
                            <q-btn
                              v-close-popup
                              label="Close"
                              color="primary"
                              flat
                            />
                          </div>
                        </q-date>
                      </q-popup-proxy>
                    </q-icon>
                  </template>
                </q-input>

                <InputDateTime
                  v-model="form.f_inicio_evento"
                  label="Inicio Evento"
                  hide-bottom-space
                  :error="validacion.has('f_inicio_evento')"
                  :error-message="validacion.first('f_inicio_evento')"
                />
                <InputDateTime
                  v-model="form.f_fin_evento"
                  label="Fin Evento"
                  hide-bottom-space
                  :error="validacion.has('f_fin_evento')"
                  :error-message="validacion.first('f_fin_evento')"
                />
              </div>
            </div>

            <!-----------------------------------------------------------------------------------------------------
                  COLUMNA 4
            ----------------------------------------------------------------------------------------------------->
            <div class="col-md-3 col-xs-12">
              <div class="q-gutter-md">
                <q-input
                  v-if="combos.area.cupo === 'S'"
                  v-model="form.cupo"
                  filled
                  dense
                  label="Cupo"
                  hide-bottom-space
                  :error="validacion.has('cupo')"
                  :error-message="validacion.first('cupo')"
                >
                  <template v-slot:prepend>
                    <q-icon name="functions" />
                  </template>
                </q-input>
                <SelectRama
                  v-if="form.beneficiarios === 'S'"
                  v-model="form.rama"
                  dense
                  filled
                  multiple
                  :gestion="false"
                  label="Ramas que participan: "
                  hide-bottom-space
                  :error="validacion.has('rama')"
                  :error-message="validacion.first('rama')"
                />
                <!--
                <q-select
                  v-model="form.genera_certificado"
                  style="min-width: 150px"
                  dense
                  filled
                  emit-value
                  stack-label
                  map-options
                  :options="[
                    { label: 'No genera', value: 'N' },
                    { label: 'Si genera', value: 'S' },
                  ]"
                  label="Generacion de Certificados: "
                  hide-bottom-space
                  :error="validacion.has('genera_certificado')"
                  :error-message="validacion.first('genera_certificado')"
                />
                -->
              </div>
            </div>
          </q-card-section>
          <q-card-actions align="right">
            <!-----------------------------------------------------------------------------------------------------
                  BOTON
            ----------------------------------------------------------------------------------------------------->
            <q-btn
              label="Crear evento"
              v-if="!form.uuid"
              @click.prevent="submitCrear"
              color="green"
            />
            <q-btn
              label="Actualizar evento"
              v-if="form.uuid"
              @click.prevent="submitActualizar"
              color="red"
            />
            <q-btn
              label="Cancelar"
              v-if="form.uuid"
              :to="'/eventos/administracion/detalle/' + form.uuid"
              color="green"
            />
          </q-card-actions>
        </q-card>
      </div>

      <div class="col-12">
        <q-card>
          <q-banner
            v-if="validacion.has('descripcion')"
            inline-actions
            class="text-white bg-red"
          >
            {{ validacion.first('descripcion') }}
          </q-banner>
          <q-editor
            v-model="form.descripcion"
            placeholder="Escriba un detalle del evento"
            dense
            :toolbar="[
              [
                {
                  label: $q.lang.editor.align,
                  icon: $q.iconSet.editor.align,
                  fixedLabel: true,
                  options: ['left', 'center', 'right', 'justify'],
                },
              ],
              [
                'bold',
                'italic',
                'strike',
                'underline',
                'subscript',
                'superscript',
              ],
              ['token', 'hr', 'link', 'custom_btn'],
              ['fullscreen'],
              [
                {
                  label: $q.lang.editor.formatting,
                  icon: $q.iconSet.editor.formatting,
                  list: 'no-icons',
                  options: ['p', 'h3', 'h4', 'h5', 'h6', 'code'],
                },
                {
                  label: $q.lang.editor.fontSize,
                  icon: $q.iconSet.editor.fontSize,
                  fixedLabel: true,
                  fixedIcon: true,
                  list: 'no-icons',
                  options: ['size-1', 'size-2', 'size-3', 'size-4', 'size-5'],
                },
                {
                  label: $q.lang.editor.defaultFont,
                  icon: $q.iconSet.editor.font,
                  fixedIcon: true,
                  list: 'no-icons',
                  options: [
                    'default_font',
                    'arial',
                    'arial_black',
                    'comic_sans',
                    'courier_new',
                    'impact',
                    'lucida_grande',
                    'times_new_roman',
                    'verdana',
                  ],
                },
                'removeFormat',
              ],
              ['quote', 'unordered', 'ordered', 'outdent', 'indent'],
              ['undo', 'redo'],
            ]"
            :fonts="{
              arial: 'Arial',
              arial_black: 'Arial Black',
              comic_sans: 'Comic Sans MS',
              courier_new: 'Courier New',
              impact: 'Impact',
              lucida_grande: 'Lucida Grande',
              times_new_roman: 'Times New Roman',
              verdana: 'Verdana',
            }"
          />
        </q-card>
      </div>
    </div>
    <Loading :showing="loading" :text="loading_text" />
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  reactive,
  onMounted,
  PropType,
  watch,
  toRef,
} from 'vue';
import { api, validacion } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import moment from 'moment';
import { useRouter, useRoute } from 'vue-router';
import Loading from 'src/components/Loading.vue';
import {
  EventoInterface,
  ComboAreaInterface,
  ComboLugarInterface,
  ComboExperienciasInterface,
} from 'src/interfaces/EventosInterface';
import InputBuscar from 'components/Personas/InputBuscar.vue';
import InputDateTime from 'components/Form/InputDateTime.vue';
import SelectRama from 'components/Form/selectRama.vue';
import { useUserStore } from 'src/stores/user';

export default defineComponent({
  name: 'EventosCreacionPage',

  props: {
    area: {
      type: String as PropType<string>,
      default: '',
    },
  },

  components: { InputBuscar, InputDateTime, SelectRama, Loading },
  setup(props) {
    const store = useUserStore();
    const loading = ref<boolean>(true);
    const loading_text = ref<string>('Obteniendo Datos');

    //const eventoArea = ref<string | number>(props.area); // se defini en el listado de ingreso de creacion al antes de instanciar el fomulario
    const eventoArea = toRef(props, 'area'); // se defini en el listado de ingreso de creacion al antes de instanciar el fomulario

    watch(
      () => props.area,
      () => {
        eventoArea.value = props.area;
      }
    );

    const router = useRouter();

    const route = useRoute();
    const uuid = String(
      route.params.uuid === undefined ? '' : route.params.uuid
    );

    const form = ref<EventoInterface>({
      uuid: '',
      organismos_id: 0,
      nombre: '',
      eventos_tipo_id: undefined,
      eventos_area_id: undefined,
      ams_experiencias_id: undefined,
      f_inicio_evento: '',
      f_fin_evento: '',
      f_cierre_inscripcion: '',
      descripcion: '',
      costo: 0,
      participa: '',
      remera: '',
      beneficiarios: '',
      rama: [],
      modalidad: 'P',
      responsable: '',
      responsable_id: 0,
      carga_horaria: 0,
      eventos_lugar_id: 1,
      eventos_estado_id: 0,
      cupo: 1000,
      crea_ams: 'N',
      genera_certificado: 'N',
      responsable_uuid: '',
    });

    const combos = reactive({
      area: <ComboAreaInterface>{},
      lugar: <ComboLugarInterface[]>[],
      experiencias: <ComboExperienciasInterface[]>[],
    });

    const evento = reactive({
      eventos_tipo_id: 1,
      responsable_uuid: null,
      rama: [],
    });

    onMounted(() => {
      if (uuid === '') {
        // si paso un uuid, primero tengo que obtener el evento, para saber que tipo de area es
        obtenetData();
      } else {
        getEvento();
      }
    });

    function cambiarModalidad(value: string) {
      if (value === 'V') {
        form.value.eventos_lugar_id = 2;
      } else {
        if (form.value.eventos_lugar_id === 2) {
          form.value.eventos_lugar_id = 1;
        }
      }
    }

    function getEvento() {
      loading.value = true;

      api
        .get('/api/eventos/eventos/' + uuid + '/editar')
        .then((response: AxiosResponse) => {
          form.value = <EventoInterface>response.data;

          form.value.f_inicio_evento = moment(
            form.value.f_inicio_evento
          ).format('YYYY/MM/DD HH:mm');
          form.value.f_fin_evento = moment(form.value.f_fin_evento).format(
            'YYYY/MM/DD HH:mm'
          );
          if (form.value.rama != null) {
            // Convierto a array de nuevo las ramas, sino no lo muestra el listado
            form.value.rama = form.value.rama;
          }

          eventoArea.value = form.value.eventos_area_id || 0;

          obtenetData();
        });
    }

    function obtenetData() {
      loading.value = true;
      Promise.all([
        //-----------------------------------------------
        api
          .get('/api/eventos/area/' + eventoArea.value)
          .then((response: AxiosResponse) => {
            combos.area = response.data;
            eventoArea.value = response.data.id; // piso el valo porque siempre quiero que tenga el codigo, ya que cuando entro x edicion el valor inicial es un id

            if (uuid === '') {
              form.value.eventos_area_id = combos.area.id;
              form.value.eventos_tipo_id = combos.area.eventos_tipo[0]['id'];
              form.value.beneficiarios = combos.area.beneficiarios;
              form.value.crea_ams = combos.area.codigo === 'AMS' ? 'S' : 'N';
            }
            return Promise.resolve(true);
          }),
        //-----------------------------------------------
        api
          .get('/api/eventos/lugar?rowsPerPage=9999')
          .then((response: AxiosResponse) => {
            combos.lugar = response.data.data;
            return Promise.resolve(true);
          }),
        //-----------------------------------------------
        api
          .get('/api/formacion/experiencias')
          .then((response: AxiosResponse) => {
            combos.experiencias = response.data;
            return Promise.resolve(true);
          }),
      ]).then(() => {
        loading.value = false;
      });
    }

    function submitCrear() {
      loading_text.value = 'Enviando Datos';
      loading.value = true;

      api
        .post('/api/eventos/eventos', form.value)
        .then((response: AxiosResponse) => {
          router.push({
            path: '/eventos/administracion/detalle/' + response.data.uuid,
          });
        })
        .finally(() => {
          loading.value = false;
        });
    }
    function submitActualizar() {
      loading_text.value = 'Enviando Datos';
      loading.value = true;
      api
        .put('/api/eventos/eventos/', form.value)
        .then(() => {
          router.push({ path: '/eventos/administracion/detalle/' + uuid });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      loading,
      loading_text,
      validacion,
      submitCrear,
      submitActualizar,
      cambiarModalidad,
      eventoArea,
      evento,
      combos,
      form,
      user: store.details,
    };
  },
});
</script>
